//  IoT電子工作キット sLab-Remo2
//  3-1.Wi-Fi無線接続

// ①ライブラリを読み込み
#include <WiFi.h>

// ②ピン配置
const byte LED_PIN = 12;// LED緑
bool ledFlag = true;    // LED制御フラグ

// ③Wi-Fi設定
const char *ssid      = "##### SSID #####";
const char *password  = "### PASSWORD ###";
IPAddress ip(192, 168, 1, 123);     // IPアドレス（本機が利用するIP）
IPAddress gateway(192, 168, 1, 1);  // デフォルトゲートウェイ
IPAddress subnet(255, 255, 255, 0); // サブネットマスク

void setup(void) {
  // ④Serial設定
  Serial.begin(115200);
  Serial.println ( );
  // ⑤LED設定
  pinMode ( LED_PIN, OUTPUT );
  // ⑥無線Wi-Fi接続
  WiFi.config( ip, gateway, subnet );
  WiFi.begin ( ssid, password );
  // ⑦Wi-Fi接続処理（接続するまで無限ループ）
  while ( WiFi.status() != WL_CONNECTED ) {
    // ⑧LEDを１秒毎に点滅する
    ledFlag = !ledFlag;
    digitalWrite(LED_PIN, ledFlag);
    // ⑨１秒間Wait
    delay ( 1000 );
    Serial.print ( "." );
  }
  // ⑩Wi-Fi接続できたのでシリアルモニターにIPアドレス表示
  Serial.print ( "Wi-Fi Connected! IP address: " );
  Serial.println ( WiFi.localIP() );
  // ⑪LED点灯（Wi-Fi接続状態）
  digitalWrite ( LED_PIN, true );
}

// loop処理はありません
void loop(void){
}
