// ①onloadは画面が読み込まれた時に実行
window.onload = function () {
  // ②リモコンボタン情報の更新処理実行
  updateIr();
}

// ③リモコンボタン情報取得・表示
function updateIr() {
  var xhr = new XMLHttpRequest();
  var url = window.location.href;
  var urlarr = url.split("/");
  // ④アクセスURL作成（例：http://192.168.1.123:12193/getrem）
  url = "http://" + urlarr[2] + "/getrem";
  xhr.timeout = 5000; 
  xhr.ontimeout = function(e){
    document.getElementById('dispStatus').innerHTML = "<b>本体へのアクセスが失敗</b>";
  };
  xhr.open("GET", url);
  xhr.send("");
  xhr.addEventListener("load",function(ev){
    var resGtStr = xhr.responseText;
    var gtRecv =  JSON.parse(resGtStr);
    // ⑤ボタン10個分のデータを確認
    for ( i=0 ; i<10 ; i++) {
      // ⑥受信データ（ボタン名）が存在するか確認
      if ( gtRecv[i] != "" && typeof gtRecv[i] !== "undefined" ) {
        var idname = "spn" + i;
        if ( document.getElementById(idname) != null ) {
          // ⑦"spn0-9"が存在した場合（制御画面）にボタン名を入力
          document.getElementById(idname).innerHTML = gtRecv[i];
        } else {
          // ⑧"spn0-9"が存在しない場合（設定画面）にボタン名を"ir0-9"に入力
          idname = "ir" + i;
          document.getElementById(idname).value = gtRecv[i];
        }
      } else {
        // ⑨"btn0-9"が存在した場合（制御画面）でボタン名がなければボタンを無効化
        var idname = "btn" + i;
        if ( document.getElementById(idname) != null ) {
          document.getElementById(idname).disabled = true;
        }
      }
    }
  });
}

// ⑩グローバル変数を定義（送受信の関数で利用）
irFlg=false;    // 受信処理中フラグ（true:処理中、false:処理可能）
flgRed=true;    // 状態表示の表示・非表示フラグ
count=0;        // １秒毎にカウントしタイムアウト判定用
rcvTimer=15;    // タイムアウト秒数

// ⑪リモコン信号処理
function snd(setNum) {
  // ⑫処置中判定
  if (irFlg) {
    // ⑬処置中の場合は処理中表示し終了
    document.getElementById('dispStatus').innerHTML = "<b>処理中です</b>";
    return;
  }
  // ⑭処置フラグを処理中とし、受信中表示処理実施
  irFlg=true;
  document.getElementById('dispStatus').innerHTML = "<b>リモコン送信中</b>";
  var xhr = new XMLHttpRequest();
  var url = window.location.href;
  var urlarr = url.split("/");
  // ⑮アクセスURL作成（例：http://192.168.1.123:12193/cntrem?n=1）
  url = "http://" + urlarr[2] + "/cntrem?n=" + setNum;
  xhr.timeout = 5000;
  xhr.ontimeout = function(e){
    dispfail();
  };
  xhr.open("GET", url);
  xhr.send("");
  xhr.addEventListener("load",function(ev){
    var resStr = xhr.responseText;
      // ⑯OKを受信したらif文内を状態表示。それ以外はelse内を状態表示
    if ( resStr.indexOf("OK") != -1 ) {
      document.getElementById('dispStatus').innerHTML = "<b>リモコン送信しました。</b>";
    } else {
      document.getElementById('dispStatus').innerHTML = "<b>リモコン送信に失敗しました。</b>";
    }
    // ⑰処置フラグを戻す
    irFlg=false;
  });
}

// ⑱リモコン受信処理
function rcv(setNum){
  // ⑲処理カウンタリセット
  count = 0;
  // ⑳処置中判定
  if (irFlg) {
    // ㉑処置中の場合は処理中表示し終了
    document.getElementById('dispStatus').innerHTML = "<b>処理中です</b>";
    return;
  }
  // ㉒処置フラグを処理中とし、受信中表示処理実施
  irFlg=true;
  setMsgTenmetu();
  // ㉓入力したボタン名を取得
  var idname = "ir" + setNum;
  var setName = document.getElementById(idname).value;
  // ㉔受信設定処理へ本体へアクセス
  var xhr = new XMLHttpRequest();
  var url = window.location.href;
  var urlarr = url.split("/");
  url = "http://" + urlarr[2] + "/setrem?n=" + setNum + "&a=" + setName;
  xhr.timeout = rcvTimer * 1000;
  xhr.ontimeout = function(e){
    dispfail();
  };
  xhr.open("GET", url);
  xhr.send("");
  xhr.addEventListener("load",function(ev){
    var resStr = xhr.responseText;
    // ㉕OKを受信したらif文内を状態表示。それ以外はelse内を状態表示
    if ( resStr.indexOf("OK") != -1 ) {
      // ㉖フラグを受信完了へ。状態表示に完了表示
      irFlg=false;
      document.getElementById('dispStatus').innerHTML = "<b>リモコン設定が完了しました。</b>";
    } else {
      // ㉗失敗表示
      dispfail();
    }
  });
}

// ㉘状態表示の点滅処理（リモコン受信中）
function setMsgTenmetu(){
  // ㉙受信完了していない。かつ、タイムアウト前
  if (irFlg == true && count < rcvTimer )　{    // 受信完了してなければ
    // ㉚flgRedで１秒毎にIF文内とelse文内を交互に表示（受信中を点滅）
    if(flgRed){
      document.getElementById('dispStatus').innerHTML = "<b>リモコン受信中（" + rcvTimer + "秒間）</b>";
    }else{
      document.getElementById('dispStatus').innerHTML = "<br>";
    }
    // ㉛状態表示状態を反転
    flgRed=!flgRed;
    // ㉜１秒後に、再度setMsgTenmetu()を実行
    setTimeout("setMsgTenmetu()",1000);
    count++;
  // ㉝タイムアウトしていた場合は失敗処理へ
  } else if (count >= rcvTimer) {
    dispfail(); 
  }
}

// ㉞失敗時の表示
function dispfail(){
  // ㉟点滅しないようにタイマーアウトにカウントを合わせる
  count=rcvTimer;
  irFlg=false;
  // ㊱状態に失敗を表示
  document.getElementById('dispStatus').innerHTML = "<b>リモコン受信に失敗しました。</b>";
}

